' Die Prozedur Check_DBF prft, ob eine als .dbf gekennzeichnete Datei
'  - eine DBF Datei ist
'  - alle Feldarten gltig sind
'  - ob eine erforderliche Memodatei vorhanden ist.

' Version 1.0  10.8.2002.       Die Prozedur kann frei benutzt werden, fr
'                               Schden kann keine Haftung bernommen werden.
'  Autor: Gerhard Putschalka    
'                        email: g.putschalka@web.de
'                     homepage: http://members.telering.at/g.putschalka/index.html

' ACHTUNG. Um eventuelle Probleme zu vermeiden wird in der Prozedur der Filemode auf
' Null, und am Ende der Prozedur, (wieder) auf 2 gesetzt.
' Wird also im Programm der Filemode auf einen bestimmten Wert gesetzt, ist dies nach
' der Ausfhrung der Prozedur  Check_DBF  auszufhren!

Proc Check_DBF 
   Parameters File$
   Declare Vorspann&,Siz1&,Db_Check#,RetVal&,Typ$,X%,MKz%
   RetVal& = 0
   Dim Db_Check#,32

   ' 1. Satzlnge, Anzahl Stze  und Vorspanngre einlesen
   FileMode 0
   Assign #1,File$
   OpenRW #1
   @BlockRead(#1,Db_Check#,0,32)
   Vorspann& = @Word(Db_Check#,8)
   Siz1& = @Long(Db_Check#,4) * @Word(Db_Check#,10) ' Anzahl Datenbytes
   Siz1& = Siz1& + Vorspann&          ' plus Bytes im Vorspann
   Siz1& = Siz1& + 1                ' plus Dateiende-Byte
   Siz1& = (Siz1& - @FileSize(File$))

   ' 2. ist der Wert 0, wird weiter geprft, sonst setze RetVal& auf 4 und beende
   IfNot (Siz1& = 0)
      RetVal% = 4
   Else
      Vorspann& = @Int(((Vorspann& - 33) / 32)) ' = Anzahl der Felder
      ' 3. prfe auf gltige Feldarten. Bei Memofeld setze Kennzeichen
      X% = 0
      MKz% = 0
      While (X% < Vorspann&)
         @BlockRead(#1,Db_Check#,0,32)
         Typ$ = @Char$(Db_Check#,11,1)
         If @Equ$(Typ$,"C")
         ElseIf @Equ$(Typ$,"D")
         ElseIf @Equ$(Typ$,"L")
         ElseIf @Equ$(Typ$,"M")
            MKz% = 1
         ElseIf @Equ$(Typ$,"N")
         Else
            RetVal& = 1
         EndIf
         Inc X%
      EndWhile
      ' 4. wurde ein Memofeld entdeckt: prfe auf Vorhandensein der Memodatei
      If MKz%
         File$ = @Substr$(File$,1,".");".dbt"
         @FindFirst$(File$)
         CaseNot (%IoResult = 0) : RetVal& = RetVal& + 2
      EndIf
   EndIf
   CloseRW #1
   Dispose Db_Check#
   FileMode 2
   Return RetVal&
EndProc